// CSCI 201 Lecture 03 practice
// Sample solution 

public class CircleCountry {

    // Returns true if point (x,y) is inside circle determined by cx, cy, and r
    // and returns false otherwise
    public static boolean isInside(int x, int y, int cx, int cy, int r) {
        // return the result of testing whether the square of the distance
        // from (cx, cy) to (x, y) is less than the square of the radius
        // fill this in here
        double distanceSquared = (x-cx)*(x-cx) + (y-cy)*(y-cy);
        double radiusSquared = r*r;
        return distanceSquared < radiusSquared;
    }

    public static int leastBorders(int[] x, int[] y, int[] r, int x1, int y1, int x2, int y2) {
        int crosses = 0;
        // loop through all circles
        for (int k = 0; k < x.length; k++) {
            // if exactly one of (x1, y1) and (x2, y2) is inside circle k 
            // (specified by x[k], y[k], and r[k]), then increment crosses
            if ((isInside(x1, y1, x[k], y[k], r[k]) && ! isInside(x2, y2, x[k], y[k], r[k])) ||
                (isInside(x2, y2, x[k], y[k], r[k]) && ! isInside(x1, y1, x[k], y[k], r[k]))) {
                crosses += 1;
            }
        }
        return crosses;
    }

    public static void main(String[] args) {
        int x1;
        int y1;
        int x2;
        int y2;
        
        // Example 1
        int[] example1_x = {0};
        int[] example1_y = {0};
        int[] example1_r = {2};
        x1 = -5;
        y1 = 1;
        x2 = 5;
        y2 = 1;
        System.out.println(leastBorders(example1_x, example1_y, example1_r, x1, y1, x2, y2));

        // Example 2
        int[] example2_x = {0, -6, 6};
        int[] example2_y = {0, 1, 2};
        int[] example2_r = {2, 2, 2};
        x1 = -5;
        y1 = 1;
        x2 = 5;
        y2 = 1;
        System.out.println(leastBorders(example2_x, example2_y, example2_r, x1, y1, x2, y2));
    }
}
